package com.xdocletbook.mock;

import junit.framework.TestCase;

public class FullServiceStationTest extends TestCase {

  public FullServiceStationTest(String name) {
    super(name);
  }

  public void testServiceAutomobile() {
    AutomobileMock auto = new AutomobileMock();
    
    // SET PRECONDITIONS
    auto.clear();
    auto.addActualGetTankCapacityReturnValue(17);
    auto.addActualGetCurrentTankLevelReturnValue(3);
    
    auto.addActualIsFrontLeftTireInflatedReturnValue(true);
    auto.addActualIsFrontRightTireInflatedReturnValue(false);
    auto.addActualIsRearRightTireInflatedReturnValue(true);
    auto.addActualIsRearLeftTireInflatedReturnValue(true);

    // SET EXPECTATIONS
    auto.setExpectedGetTankCapacityCalls(1);
    auto.setExpectedGetCurrentTankLevelCalls(1);
    auto.setExpectedAddOneGallonCalls(14);
    
    auto.setExpectedIsFrontLeftTireInflatedCalls(1);
    auto.setExpectedIsFrontRightTireInflatedCalls(1);
    auto.setExpectedIsRearLeftTireInflatedCalls(1);
    auto.setExpectedIsRearRightTireInflatedCalls(1);
    auto.setExpectedInflateFrontLeftTireCalls(0);
    auto.setExpectedInflateFrontRightTireCalls(1);
    auto.setExpectedInflateRearLeftTireCalls(0);
    auto.setExpectedInflateRearRightTireCalls(0);
    
    auto.setExpectedCleanWindshieldCalls(1);
    
    auto.setExpectedSetRadioStationFloatCalls(0);
   
    FullServiceStation station = new FullServiceStation();
   // station.serviceAutomobile(auto);
   
    auto.verify();
  }
}
