package com.xdocletbook.portlets;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

import javax.portlet.PortletPreferences;
import javax.portlet.PreferencesValidator;
import javax.portlet.ValidatorException;

public class WeatherPreferenceValidator 
    implements PreferencesValidator{

  private static String[] states = {"AZ", "NM", "TX", "PA"
      };
  private static Set stateSet = new HashSet();    

  static {
    stateSet.addAll(Arrays.asList(states));
  }

  public void validate(PortletPreferences prefs)
      throws ValidatorException {

    String state = prefs.getValue("state", "TX");
    
    if(!stateSet.contains(state)) {
      throw new ValidatorException(
          state + " is not a state.", null);
    }
  }
}
