package com.xdocletbook.blog.listener;

import java.sql.Connection;
import java.sql.DriverManager;

import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

/**
 * @web.listener
 */
public class BlogContextListener implements ServletContextListener {
  private static final String DB_URL = "";
  private static final String DB_DRIVER = "";
  
  public void contextDestroyed(ServletContextEvent contextEvent) {
    ServletContext context = contextEvent.getServletContext();
    Connection conn = (Connection)context.getAttribute("connection");

    try {
      conn.close();
    } catch (Exception e) {
      context.log("Error closing DB connection: " + e);
    }
  }

  public void contextInitialized(ServletContextEvent contextEvent) {
    ServletContext context = contextEvent.getServletContext();

    try {
      Class.forName(DB_DRIVER);
      Connection conn = DriverManager.getConnection(DB_URL);
      context.setAttribute("connection", conn);
    } catch (Exception e) {
      context.log("Error getting DB connection: " + e);
    }
  }
}
