package com.xdocletbook.blog.servlet;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;

/**
 * @web.servlet
 *     name="HomePage"
 * 
 * @web.servlet-init-param
 *     name="LogLevel"
 *     value="${LOG_LEVEL}"
 * 
 * @web.servlet-mapping
 *     url-pattern="/home"
 */
public class HomePageServlet extends HttpServlet {
  private static Logger LOGGER = 
      Logger.getLogger(HomePageServlet.class);
  
  public void init() throws ServletException {
    String logLevel = getInitParameter("LogLevel");
    
    if(logLevel != null && logLevel.length() > 0) {
      LOGGER.setLevel(Level.toLevel(logLevel));
    }
  }
  
  public void service(HttpServletRequest request,
      HttpServletResponse response)
      throws ServletException, IOException {
        
    LOGGER.debug("Displaying home page");
    request.getRequestDispatcher(
        "jsp/home.jsp").forward(request, response);
  }
}
