package com.xdocletbook.blog.tag;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

/**
 * @jsp.tag
 *     name="formatdate"
 *     body-content="empty"
 */
public class DateFormatTag extends TagSupport {
  private static final String DEFAULT_FORMAT =
      "EEEE yyyy/MM/dd hh:mmaa z";
  
  private String format = DEFAULT_FORMAT;
  private Date date;
  
  public int doEndTag() throws JspException {
    
    try {
      SimpleDateFormat formatter = new SimpleDateFormat(format);
      
      pageContext.getOut().write(formatter.format(date));
    } catch (IOException e) {
    }
    
    return EVAL_PAGE;
  }
  
  /**
   * @jsp.attribute
   *     required="true"
   *     rtexprvalue="true"
   *     type="java.util.Date"
   */
  public Date getDate() {
    return date;
  }

  public void setDate(Date date) {
    this.date = date;
  }
  
  /**
   * @jsp.attribute
   *     required="false"
   *     rtexprvalue="false"
   *     type="java.lang.String"
   */
  public String getFormat() {
    return format;
  }

  public void setFormat(String format) {
    this.format = format;
  }
}
