package com.xdocletbook.blog.struts.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.xdocletbook.blog.exception.ApplicationException;
import com.xdocletbook.blog.form.BlogCreateForm;
import com.xdocletbook.blog.interfaces.BlogFacade;
import com.xdocletbook.blog.interfaces.BlogFacadeHome;
import com.xdocletbook.blog.util.BlogFacadeUtil;

/**
 * @struts.action
 *     name="blog.Create"
 *     path="/createBlog"
 *     input="/jsp/error.jsp"
 *  
 * @struts.action-forward
 *     name="success"
 *     path="jsp/home.jsp"
 * 
 * @struts.action-exception
 *     type="com.xdocletbook.blog.exception.ApplicationException"
 *     key="app.exception"
 *     path="jsp/error.jsp"
 */
public class CreateBlogAction extends Action {
  public ActionForward execute(ActionMapping mapping, 
      ActionForm form, HttpServletRequest request, 
      HttpServletResponse response) throws Exception {

    BlogCreateForm blogForm = (BlogCreateForm)form;

    try {
      BlogFacadeHome home = BlogFacadeUtil.getHome();
      BlogFacade blogFacade = home.create();
      
      blogFacade.createBlog(
          blogForm.getName(), blogForm.getOwner(), 
          blogForm.getEmail());
          
      request.setAttribute("allBlogs", blogFacade.getAllBlogs());
    } catch (Exception e) {
      throw new ApplicationException(e);
    }

    return mapping.findForward("success");
  }
}
