package com.xdocletbook.blog.pojo;

import java.util.Collection;
import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Session;
import net.sf.hibernate.cfg.Configuration;

import com.xdocletbook.blog.exception.ApplicationException;

public class BlogFacadeHibernate implements BlogFacade {
  private Session session;
 
  public BlogFacadeHibernate() throws ApplicationException {
    try {
      Configuration configuration = new Configuration();
      
      configuration.addFile("d:/projects/xdocletbook/generated/hbm/com/xdocletbook/blog/pojo/Blog.hbm.xml");
      configuration.addFile("d:/projects/xdocletbook/generated/hbm/com/xdocletbook/blog/pojo/Entry.hbm.xml");
      configuration.addFile("d:/projects/xdocletbook/generated/hbm/com/xdocletbook/blog/pojo/Topic.hbm.xml");
      
      session = configuration.buildSessionFactory().openSession();
    } catch (HibernateException e) {
      e.printStackTrace();
      throw new ApplicationException(e);
    }
  }
  
  public Collection getAllBlogs() throws ApplicationException {
    try {
      String select = "FROM com.xdocletbook.blog.pojo.Blog blog";
      return session.find(select);
    } catch (HibernateException e) {
      throw new ApplicationException(e);
    }
  }
  
  public Blog createBlog(String name, String owner, String email) 
      throws ApplicationException {
         
    try {
      Blog blog = new Blog();

      blog.setName(name);
      blog.setOwner(owner);
      blog.setEmail(email);
      
      session.save(blog);
      
      return blog;
    } catch (HibernateException e) {
      throw new ApplicationException(e);
    }
  }
   
  public void deleteBlog(String blogId) 
      throws ApplicationException {
  
    try {
      Blog blog =(Blog) session.load(Blog.class, blogId);
      session.delete(blog);
    } catch (HibernateException e) {
      throw new ApplicationException(e);
    }
  }
   
  public Collection getTopics(String blogId)
      throws ApplicationException {

    try {
      Blog blog =(Blog) session.load(Blog.class, blogId);
        
      return blog.getTopics();
    } catch (HibernateException e) {
      throw new ApplicationException(e);
    } 
  }
   
  protected void finalize() throws Throwable {
    session.close();
  }
}
