package com.xdocletbook.blog.pojo;

import java.util.Collection;
import java.util.Properties;

import javax.jdo.JDOHelper;
import javax.jdo.PersistenceManager;
import javax.jdo.PersistenceManagerFactory;
import javax.jdo.Transaction;

/**
 */
public class BlogPersister {
  public static void main(String[] args) {
    Properties props = new Properties();
    props.setProperty("javax.jdo.PersistenceManagerFactoryClass",
        "com.triactive.jdo.PersistenceManagerFactoryImpl");
    props.setProperty("javax.jdo.option.ConnectionDriverName",
        "org.gjt.mm.mysql.Driver");
    props.setProperty("javax.jdo.option.ConnectionURL",
        "jdbc:mysql://127.0.0.1/testjdo");
    props.setProperty("javax.jdo.option.ConnectionUserName", "");
    props.setProperty("javax.jdo.option.ConnectionPassword", "");
    //props.setProperty("com.triactive.jdo.autoCreateTables", "false");
    
    PersistenceManagerFactory pmf = 
        JDOHelper.getPersistenceManagerFactory(props);
    PersistenceManager pm = pmf.getPersistenceManager();
    
    Transaction tx = pm.currentTransaction();
    try {
      tx.begin();
      
      Blog retrievedBlog = (Blog)pm.getObjectById("9d01c2c00a960028016721bd0b77c006", false);
      System.out.println("BLOG.name:  "+retrievedBlog.getName());
      System.out.println("BLOG.owner: "+retrievedBlog.getOwner());
//      Collection topics = retrievedBlog.getTopics();
//      Collection entries = retrievedBlog.getEntries();
//      System.out.println("BLOG.topics.size:  "+topics.size());
//      System.out.println("BLOG.entries.size:  "+entries.size());
//      
//      
//      Blog blog = new Blog();
//      blog.setName("Some Blog");
//      blog.setOwner("Mine");
//      blog.setEmail("MyEmail");
//      
//      pm.makePersistent(blog);
      
      tx.commit();
    } finally {
      if(tx.isActive()) tx.rollback();
      pm.close();
    }
  }
}
