package com.xdocletbook.blog.pojo;
 
import java.util.Date;

/**
 * @hibernate.class
 *    table="entry"
 * 
 * @jdo.persistence-capable
 *     identity-type="application"
 *     objectid-class="java.lang.String"
 * 
 * @castor.class
 *    id="id"
 *    table="Entry"
 *    key-generator="UUID"
 */
public class Entry {
  /**
   * @jdo.field
   *     primary-key="true"
   * 
   * @jdo.field-vendor-extension
   *     vendor-name="triactive"
   *     key="length"
   *     value="32"
   */
  private String id;
  /**
   * @jdo.field
   *     null-value="exception"
   * 
   * @jdo.field-vendor-extension
   *     vendor-name="triactive"
   *     key="length"
   *     value="unlimited"
   */
  private String text;
  /**
   * @jdo.field
   *     null-value="exception"
   * 
   * @jdo.field-vendor-extension
   *     vendor-name="triactive"
   *     key="length"
   *     value="max 80"
   */
  private String title;
  /**
   * @jdo.field
   *     null-value="exception"
   */
  private Date createdDate;
  
  /**
   * @jdo.field
   *     null-value="exception"
   */
  private Blog blog;
  
  /**
   * @jdo.field
   *     null-value="exception"
   */
  private Topic topic;
  
  public Entry() {
  }
  
  /**
   * @hibernate.id
   *     generator-class="uuid.string"
   * 
   * @castor.field
   *     set-method="setId"
   * 
   * @castor.field-sql
   *     name="id"
   *     type="char"
   */
  public String getId() {
    return id;
  }

  /**
   * @hibernate.property
   * 
   * @castor.field
   *     set-method="setText"
   * 
   * @castor.field-sql
   *     name="text"
   *     type="char"
   */
  public String getText() {
    return text;
  }

  /**
   * @hibernate.property
   * 
   * @castor.field
   *     set-method="setTitle"
   * 
   * @castor.field-sql
   *     name="title"
   *     type="char"
   */
  public String getTitle() {
    return title;
  }
  
  /**
   * @hibernate.property
   * 
   * @castor.field
   *     set-method="setCreatedDate"
   * 
   * @castor.field-sql
   *     name="createdDate"
   *     type="date"
   * 
   * @castor.field-xml
   *     type="string"
   */
  public Date getCreatedDate() {
    return createdDate;
  }

  public void setId(String string) {
    id = string;
  }

  public void setText(String string) {
    text = string;
  }

  public void setTitle(String string) {
    title = string;
  }

  public void setCreatedDate(Date date) {
    createdDate = date;
  }

  /**
   * @hibernate.many-to-one
   *     column="blog"
   * 
   * @castor.field
   *     type="com.xdocletbook.blog.pojo.Blog"
   *     set-method="setBlog"
   *
   * @castor.field-sql
   *     name="blog"
   */
  public Blog getBlog() {
    return blog;
  }

  public void setBlog(Blog blog) {
    this.blog = blog;
  }
  
  /**
   * @hibernate.many-to-one
   *     column="topic"
   * 
   * @castor.field
   *     type="com.xdocletbook.blog.pojo.Topic"
   *     set-method="setTopic"
   * 
   * @castor.field-sql
   *     name="topic"
   */
  public Topic getTopic() {
    return topic;
  }
  
  public void setTopic(Topic topic) {
    this.topic = topic;
  }
}
