package com.xdocletbook.blog.pojo;

import java.util.Set;

/**
 * @hibernate.class
 *     table="topic"
 * 
 * @jdo.persistence-capable
 *     identity-type="application"
 *     objectid-class="java.lang.String"
 * 
 * @castor.class
 *     id="id"
 *     table="Topic"
 *     key-generator="UUID"
 */
public class Topic {
  /**
   * @jdo.field
   *     primary-key="true"
   * 
   * @tjdo.field
   *     content-length="32"
   */
  private String id;
  /**
   * @jdo.field
   *     null-value="exception"
   * 
   * @jdo.field-vendor-extension
   *     vendor-name="triactive"
   *     key="length"
   *     value="max 30"
   */
  private String name;
  
  /**
   * @jdo.field
   *     null-value="exception"
   */
  private Blog blog;
  
  /**
   * @jdo.field
   *     collection-type="collection"
   *     element-type="com.xdocletbook.blog.pojo.Entry"
   */
  private Set entries;
  
  public Topic() {
  }
  
  /**
   * @hibernate.id
   *     generator-class="uuid.string"
   * 
   * @castor.field
   *     set-method="setId"
   * 
   * @castor.field-sql
   *     name="id"
   *     type="char"
   * 
   * @castor.field-xml
   *     name="id"
   *     node="attribute"
   */
  public String getId() {
    return id;
  }

  /**
   * @hibernate.property
   * 
   * @castor.field
   *     set-method="setName"
   * 
   * @castor.field-sql
   *     name="name"
   *     type="char"
   * 
   * @castor.field-xml
   *     name="name"
   */
  public String getName() {
    return name;
  }

  public void setId(String string) {
    id = string;
  }

  public void setName(String string) {
    name = string;
  }
  
  /**
   * @hibernate.many-to-one
   * 
   * @castor.field
   *     type="com.xdocletbook.blog.pojo.Blog"
   *     set-method="setBlog"
   *
   * @castor.field-sql
   *     name="blog"
   */
  public Blog getBlog() {
    return blog;
  }

  public void setBlog(Blog blog) {
    this.blog = blog;
  }
  
  /**
   * @hibernate.set
   *     lazy="true"
   *     cascade="all"
   *     readonly="true"
   * 
   * @hibernate.collection-key
   *     column="topic"
   *     generator-class="uuid.string"
   * 
   * @hibernate.collection-one-to-many
   *     class="com.xdocletbook.blog.pojo.Entry"
   * 
   * @castor.field
   *     collection="set"
   *     type="com.xdocletbook.blog.pojo.Entry"
   *     set-method="setEntries"
   * 
   * @castor.field-sql
   *     many-key="topic"
   * 
   * @castor.field-xml
   *     name="entry"
   */
  public Set getEntries() {
    return entries;
  }
  
  public void setEntries(Set entries) {
    this.entries = entries;
  }
}
