package com.xdocletbook.blog.pojo;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.Reader;
import java.io.Writer;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import org.exolab.castor.mapping.Mapping;
import org.exolab.castor.xml.Marshaller;
import org.exolab.castor.xml.Unmarshaller;

/**
 */
public class XMLTester {
  public static void main(String[] args) throws Exception {
    Blog blog = new Blog();
    blog.setName("Blog Name");
    blog.setOwner("Blog Owner");
    blog.setEmail("Blog@blog.com");
    blog.setId("12345");
    
    Topic topic = new Topic();
    topic.setId("54321");
    topic.setName("Test Topic");
    
    Topic topic2 = new Topic();
    topic2.setId("ABCDEF");
    topic2.setName("Booger Topic");
    
    Topic topic3 = new Topic();
    topic3.setId("zxyfhj");
    topic3.setName("Another Topic");
    
    Set topics = new HashSet();
    topics.add(topic2);
    topics.add(topic);
    topics.add(topic3);

    
    blog.setTopics(topics);
    
    Writer writer = new FileWriter("SomeBlog.xml");

    Mapping mapping = new Mapping();
    mapping.loadMapping("d:/projects/xdocletbook/generated/castor/mapping.xml");
    Marshaller marshaller = new Marshaller(writer);
    marshaller.setMapping(mapping);
    marshaller.marshal(blog);
    
    Reader reader = new FileReader("SomeBlog.xml");
    Mapping mapping2 = new Mapping();
    mapping2.loadMapping("d:/projects/xdocletbook/generated/castor/mapping.xml");    
    Unmarshaller unmarshaller = new Unmarshaller();
    unmarshaller.setMapping(mapping);
    Blog blog2 = (Blog)unmarshaller.unmarshal(reader);
    
    System.out.println("BLOG2.id="+blog2.getId());
    System.out.println("BLOG2.name="+blog2.getName());
    System.out.println("BLOG2.owner="+blog2.getOwner());
    System.out.println("BLOG2.email="+blog2.getEmail());
    Set topicSet = blog2.getTopics();
   
    
    System.out.println("TOPIC.size:  "+topicSet.size());
 
    for(Iterator iter = topicSet.iterator(); iter.hasNext(); ) {
      Topic t = (Topic)iter.next();
      System.out.println("TOPIC:  "+t.getName());
    }

  }
}
