package com.xdocletbook.jmx;

/**
 * @jmx.mbean
 *     name="Memory:name=memoryMonitor"
 *     description="Memory Monitor MBean"
 * 
 * @jmx.mlet-entry
 *     archive="MemoryMonitorMBean.jar"
 * 
 * @jboss.service servicefile="jboss"
 * 
 * @jboss.xmbean
 */
public class MemoryMonitor implements MemoryMonitorMBean {
  public MemoryMonitor() {
  }
  
  /**
   * @jmx.managed-attribute
   *    description="Amount of free memory available"
   *     access="read-only"
   */
  public long getAvailableMemory() {
    return Runtime.getRuntime().freeMemory();
  }
  
  /**
   * @jmx.managed-attribute
   *     access="read-only"
   */
  public long getTotalMemory() {
    return Runtime.getRuntime().totalMemory();
  }
  
  /**
   * @jmx.managed-attribute
   *     access="read-only"
   */
  public long getMaxMemory() {
    return Runtime.getRuntime().maxMemory();
  }
}
