package com.xdocletbook.jmx.client;

import javax.management.MBeanServer;
import javax.management.MBeanServerFactory;
import javax.management.ObjectName;

import com.xdocletbook.jmx.BlogManager;

import mx4j.adaptor.http.HttpAdaptor;

/**
 */
public class Mx4JBoot {
  private MBeanServer server;
  private HttpAdaptor httpAdaptor;
  
  private Mx4JBoot() {
    server = MBeanServerFactory.createMBeanServer("BlogAgent");    
  }
  
  public static void main(String[] args) {
    Mx4JBoot boot = new Mx4JBoot();
    try {
      System.out.println("STARTING MBEAN SERVER");
      boot.startBlogManager();
      boot.startHttpAdaptor();
      
      while(true) {
        Thread.sleep(5000);
      }
    } catch (Exception e) {
      e.printStackTrace();
    } finally {   
      System.out.println("STOPPING MBEAN SERVER");   
    }
  }
  
  private void startBlogManager() throws Exception {
    server.registerMBean(new BlogManager(), 
        new ObjectName("BlogAgent:name=blogManager"));
  }
  
  private void startHttpAdaptor() throws Exception {
    httpAdaptor = new HttpAdaptor();
    httpAdaptor.setPort(9093);

    server.registerMBean(httpAdaptor, 
        new ObjectName("Server:name=HttpAdaptor"));
    httpAdaptor.start();
  }
}
